;Some 16-bit math routines I wrote for MLC86...
;Divide-by-65535 bug fixed, div16 now rounds down (probably more useful in most cases)
;If you have any questions, comments, etc. please e-mail me at straney@umbi.umd.edu


;===============16-bit multiply by Donald Straney==============
;
;35 bytes/6227 cycles max.
;Inputs: hl, de - numbers to multiply
;Outputs: hl is result, c set if answer out of range
;

mult16:
	ld a,d
	or a
	jr z,mult16_de
mult16_hl:
	ld b,l
	ld a,h
	or a
	jr nz,mult16_err
	ex de,hl
	jr mult16_go
mult16_de:
	ld b,e
	ld a,d
	or a
	jr nz,mult16_err
mult16_go:
	ld a,b
	or a
	jr z,mult16_0
	dec b
	ret z
	ld d,h
	ld e,l
mult16_loop:
	add hl,de
	djnz mult16_loop
	xor a
	ret
mult16_0:
	ld hl,0
	xor a
	ret
mult16_err:
	scf
	ret


;===============16-bit divide by Donald Straney==============
;
;56 bytes/(283+hl/de*81) cycles
;Inputs: hl, de - numbers to divide
;Outputs: hl=hl/de (rounds down)
;

div16:
	call _cphlde
	jr z,div16_1
	jr c,div16_0
	push hl
	ld hl,1
	call _cphlde
	pop hl
	ret z
	ld c,e
	ld b,d
	ex de,hl
	ld ix,0
	ld hl,0
div16_loop:
	add hl,bc
	jp c,div16_end
	inc ix
	push hl
	or a
	sbc hl,de
	pop hl
	jp c,div16_loop
	jr z,div16_end
	dec ix
div16_end:
	push ix
	pop hl
	ret
div16_1:
	ld hl,1
	ret
div16_0:
	ld hl,0
	ret

.end